/*
Copyright 2003/2004, Freie Universitaet Berlin. All rights reserved.

These sources were developed at the Freie Universitt Berlin, Computer
Systems and Telematics group.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are
met:

- Redistributions of source code must retain the above copyright
notice, this list of conditions and the following disclaimer.

- Redistributions in binary form must reproduce the above copyright
notice, this list of conditions and the following disclaimer in the
documentation and/or other materials provided with the distribution.
 
- Neither the name of Freie Universitaet Berlin (FUB) nor the names of its
contributors may be used to endorse or promote products derived from
this software without specific prior written permission.

This software is provided by FUB and the contributors on an "as is"
basis, without any representations or warranties of any kind, express
or implied including, but not limited to, representations or
warranties of non-infringement, merchantability or fitness for a
particular purpose. In no event shall FUB or contributors be liable
for any direct, indirect, incidental, special, exemplary, or
consequential damages (including, but not limited to, procurement of
substitute goods or services; loss of use, data, or profits; or
business interruption) however caused and on any theory of liability,
whether in contract, strict liability, or tort (including negligence
or otherwise) arising in any way out of the use of this software, even
if advised of the possibility of such damage.

This implementation was developed by the CST group at the FUB.
Contributors: Marco Hutta

For documentation and questions please use the web site
http://www.scatterweb.net and the mailinglist
scatterweb@lists.spline.inf.fu-berlin.de (subscription via the Website).
Berlin, 2003/2004/2005
*/

#ifndef ScatterWeb_Threading
#define ScatterWeb_Threading

// current task
extern volatile UINT16 Threading_currentThread;

/*
 * Initializes the threading
 * 
 * @param return    True always  
 *  
 */
bool Threading_init();

/*
 * Adds thread
 * 
 * @return bool     True if successful, otherwise False
 *  
 */
bool Threading_add(void* address);

/*
 * Does events
 * 
 * @return bool     True always
 *  
 */
bool Threading_doEvents();

/*
 * Sleeps for ticks
 * 
 * @return bool     True always
 *  
 */
bool Threading_sleep(UINT16 ticks);

/*
 * Waits until address == bitmask
 * 
 * @return bool     True always
 *  
 */
bool Threading_wait(UINT8* adr, UINT8 bitmask);

/* 
 * This members support the ScatterWeb infrastructure
 * and are not intended to be used directly from your code.
 */ 
bool Threading_eventHandler(); 
bool Threading_packetHandler();
bool Threading_sentPacketHandler(UINT16 p, UINT16 success);
bool Threading_recv(UINT16 sender, UINT16 type, UINT16 timeout);
bool Threading_recvp(UINT16 sender, UINT16 type, UINT16 timeout);
bool Threading_send(UINT16 to, UINT16 type, UINT8* h, UINT16 hl, UINT8* d, UINT16 dl);
bool Threading_esend(UINT16 to, UINT16 type, UINT8*h, UINT16 hl, UINT16 d, UINT16 dl);

#endif
