/*
Copyright 2003/2004, Freie Universitaet Berlin. All rights reserved.
 
These sources were developed at the Freie Universitt Berlin, Computer
Systems and Telematics group.

Redistribution and use in source and binary forms, with or without
modification, are permitted provided that the following conditions are
met:
 
- Redistributions of source code must retain the above copyright
notice, this list of conditions and the following disclaimer.
  
- Redistributions in binary form must reproduce the above copyright 
notice, this list of conditions and the following disclaimer in the
documentation and/or other materials provided with the distribution.
 
- Neither the name of Freie Universitaet Berlin (FUB) nor the names of its
contributors may be used to endorse or promote products derived from
this software without specific prior written permission.

This software is provided by FUB and the contributors on an "as is"
basis, without any representations or warranties of any kind, express
or implied including, but not limited to, representations or
warranties of non-infringement, merchantability or fitness for a
particular purpose. In no event shall FUB or contributors be liable
for any direct, indirect, incidental, special, exemplary, or
consequential damages (including, but not limited to, procurement of
substitute goods or services; loss of use, data, or profits; or
business interruption) however caused and on any theory of liability,
whether in contract, strict liability, or tort (including negligence
or otherwise) arising in any way out of the use of this software, even
if advised of the possibility of such damage.

This implementation was developed by the CST group at the FUB.
Contributors: Marco Hutta

For documentation and questions please use the web site
http://scatterweb.mi.fu-berlin.de and the mailinglist
scatterweb@lists.spline.inf.fu-berlin.de (subscription via the Website).
Berlin, 2003/2004/2005
*/

#ifndef ScatterWeb_Timers
#define ScatterWeb_Timers

#include "ScatterWeb.System.h"

// Terminal command function pointer type, argument is the command.
typedef void(*fp_timer)(UINT16);

/*
 * Function to init timers
 * 
 * @return bool     True always  
 *  
 */
bool Timers_init();

/*
 * Function to add timers
 *  
 * @return bool     True if successful, otherwise False
 *  
 */
bool Timers_add(UINT16 ticks, fp_timer fp, UINT16 data);

/*
 * Function to reset timers
 *  
 * @return bool     True if successful, otherwise False
 *  
 */
bool Timers_reset(UINT16 t, fp_timer fp, UINT16 data);

/*
 * Function to remove timers
 *  
 * @return bool     True if successful, otherwise False
 *  
 */
bool Timers_remove(fp_timer fp, UINT16 data);

/* 
 * This member supports the ScatterWeb infrastructure
 * and is not intended to be used directly from your code.
 */
bool Timers_eventHandler();

#endif
